<script setup>
import TableContent from '@/Components/Unified/TableContent.vue';
import { Link, router, usePage } from '@inertiajs/vue3';
import { onMounted, reactive, ref } from 'vue';
import { setupPopup, openItems } from '@/store.js';
const page = usePage();
const props = defineProps({
    isEngineering: Boolean,
    isChild: Boolean,
    isActive: Boolean,
    isDetail: Boolean,
    parentSaleCoeff: {
        type: Number,
        default: 0,
    },
    parentSendCoeff: {
        type: Number,
        default: 0,
    },
    parentAmount: {
        type: Number,
        default: 1,
    },
    item: Object,
    parentId: String,
});
const types = {
    1: {
        name: 'Компл.',
        link: 'items',
    },
    2: {
        name: 'Дет.',
        link: 'details',
    },
    3: {
        name: 'Оборуд.',
        link: 'equipments',
    },
    4: {
        name: 'Доп.',
        link: 'customs',
    },
};
const model = defineModel();
const state = reactive({
    link: types[props.item.type].link,
    type: types[props.item.type].name,
    full: props.parentId ? props.parentId + '_' + props.item.type + '_' + props.item.id : props.item.type + '_' + props.item.id,
});
const changeParam = (param) => {
    router.post('/element/set', {
        id: props.item.id,
        param: param,
        value: props.item[param],
    }, {
        preserveScroll: true,
    });
}
/* Удаляем контент и всё, куда он входит */
const deleteContent = async () => {
    let result = confirm('Вы уверены?\nУдаление позиции и всех дочерних компонентов');
    if (result) {
        let link = '/hide';
        await axios.post(link, {
            id: props.item.id,
        }).then((response) => {
            router.visit(route(route().current(), route().params), {
                only: ['items'],
                preserveScroll: true,
            });
        })
    }
}

const restoreContent = async () => {
    let result = confirm('Вы уверены?\nВосстановление позиции и всех удалённых дочерних компонентов');
    if (result) {
        let link = '/restore'
        await axios.post(link, {
            id: props.item.id,
        }).then((response) => {
            router.visit(route(route().current(), route().params), {
                only: ['items'],
                preserveScroll: true,
            });
        })
    }
}

const destroyContent = async () => {
    let result = confirm('Вы уверены?\nУдаление позиции и всех родительских элементов, в которые она входит\nДанное действие необратимо');
    if (result) {
        let link = '/destroy'
        await axios.post(link, {
            id: props.item.id,
        }).then((response) => {
            router.visit(route(route().current(), route().params), {
                only: ['items'],
                preserveScroll: true,
            });
        })
    }
}

const changeOpen = () => {
    openItems.inner[state.full] = (openItems.inner[state.full]) ? 0 : 1;
}

function formatMoney(amount, decimalCount = 2, decimal = ".", thousands = ",") {
    try {
        decimalCount = Math.abs(decimalCount);
        decimalCount = isNaN(decimalCount) ? 2 : decimalCount;
        const negativeSign = amount < 0 ? "-" : "";
        let i = parseInt(amount = Math.abs(Number(amount) || 0).toFixed(decimalCount)).toString();
        let j = (i.length > 3) ? i.length % 3 : 0;
        return negativeSign +
            (j ? i.substr(0, j) + thousands : '') +
            i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousands) +
            (decimalCount ? decimal + Math.abs(amount - i).toFixed(decimalCount).slice(2) : "");
    } catch (e) {
        console.log(e)
    }
};

</script>
<template>
    <tr class="item" :class="{
        '_hidden': props.isChild && !props.isActive,
        '_open': openItems.inner[state.full],
        '_child': props.isChild,
        '_item': props.item.type == 1,
    }">
        <template v-if="isEngineering">
            <td>
                <template v-if="page.props.deleted">
                    <div class="table-icons" v-if="!props.isChild">
                        <div class="table-icon" @click="restoreContent()">
                            <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 0 24 24"
                                fill="none">
                                <g id="SVGRepo_bgCarrier" stroke-width="0" />
                                <g id="SVGRepo_tracerCarrier" stroke-linecap="round" stroke-linejoin="round" />
                                <g id="SVGRepo_iconCarrier">
                                    <path
                                        d="M4.52185 7H7C7.55229 7 8 7.44772 8 8C8 8.55229 7.55228 9 7 9H3C1.89543 9 1 8.10457 1 7V3C1 2.44772 1.44772 2 2 2C2.55228 2 3 2.44772 3 3V5.6754C4.26953 3.8688 6.06062 2.47676 8.14852 1.69631C10.6633 0.756291 13.435 0.768419 15.9415 1.73041C18.448 2.69239 20.5161 4.53782 21.7562 6.91897C22.9963 9.30013 23.3228 12.0526 22.6741 14.6578C22.0254 17.263 20.4464 19.541 18.2345 21.0626C16.0226 22.5842 13.3306 23.2444 10.6657 22.9188C8.00083 22.5931 5.54702 21.3041 3.76664 19.2946C2.20818 17.5356 1.25993 15.3309 1.04625 13.0078C0.995657 12.4579 1.45216 12.0088 2.00445 12.0084C2.55673 12.0079 3.00351 12.4566 3.06526 13.0055C3.27138 14.8374 4.03712 16.5706 5.27027 17.9625C6.7255 19.605 8.73118 20.6586 10.9094 20.9247C13.0876 21.1909 15.288 20.6513 17.0959 19.4075C18.9039 18.1638 20.1945 16.3018 20.7247 14.1724C21.2549 12.043 20.9881 9.79319 19.9745 7.8469C18.9608 5.90061 17.2704 4.3922 15.2217 3.6059C13.173 2.8196 10.9074 2.80968 8.8519 3.57803C7.11008 4.22911 5.62099 5.40094 4.57993 6.92229C4.56156 6.94914 4.54217 6.97505 4.52185 7Z"
                                        fill="#ffffff" />
                                </g>
                            </svg>
                        </div>
                        <template v-if="false">
                            <div class="table-icon" @click="destroyContent()">
                                <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 0 24 24"
                                    fill="none">
                                    <path d="M3 6.98996C8.81444 4.87965 15.1856 4.87965 21 6.98996" stroke="#000000"
                                        stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                                    <path
                                        d="M8.00977 5.71997C8.00977 4.6591 8.43119 3.64175 9.18134 2.8916C9.93148 2.14146 10.9489 1.71997 12.0098 1.71997C13.0706 1.71997 14.0881 2.14146 14.8382 2.8916C15.5883 3.64175 16.0098 4.6591 16.0098 5.71997"
                                        stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                        stroke-linejoin="round" />
                                    <path d="M12 13V18" stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                        stroke-linejoin="round" />
                                    <path
                                        d="M19 9.98999L18.33 17.99C18.2225 19.071 17.7225 20.0751 16.9246 20.8123C16.1266 21.5494 15.0861 21.9684 14 21.99H10C8.91389 21.9684 7.87336 21.5494 7.07541 20.8123C6.27745 20.0751 5.77745 19.071 5.67001 17.99L5 9.98999"
                                        stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                        stroke-linejoin="round" />
                                </svg>
                            </div>
                        </template>
                    </div>
                </template>
                <template v-else>
                    <div class="table-icons" v-if="!props.isChild">
                        <div class="table-icon" @click="setupPopup('edit', props.item.id)">
                            <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 0 24 24"
                                fill="none">
                                <path
                                    d="M21.2799 6.40005L11.7399 15.94C10.7899 16.89 7.96987 17.33 7.33987 16.7C6.70987 16.07 7.13987 13.25 8.08987 12.3L17.6399 2.75002C17.8754 2.49308 18.1605 2.28654 18.4781 2.14284C18.7956 1.99914 19.139 1.92124 19.4875 1.9139C19.8359 1.90657 20.1823 1.96991 20.5056 2.10012C20.8289 2.23033 21.1225 2.42473 21.3686 2.67153C21.6147 2.91833 21.8083 3.21243 21.9376 3.53609C22.0669 3.85976 22.1294 4.20626 22.1211 4.55471C22.1128 4.90316 22.0339 5.24635 21.8894 5.5635C21.7448 5.88065 21.5375 6.16524 21.2799 6.40005V6.40005Z"
                                    stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                                <path
                                    d="M11 4H6C4.93913 4 3.92178 4.42142 3.17163 5.17157C2.42149 5.92172 2 6.93913 2 8V18C2 19.0609 2.42149 20.0783 3.17163 20.8284C3.92178 21.5786 4.93913 22 6 22H17C19.21 22 20 20.2 20 18V13"
                                    stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                            </svg>
                        </div>
                        <div class="table-icon" @click="setupPopup('copy', props.item.id)">
                            <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 -0.5 25 25"
                                fill="none">
                                <path fill-rule="evenodd" clip-rule="evenodd"
                                    d="M17.676 14.248C17.676 15.8651 16.3651 17.176 14.748 17.176H7.428C5.81091 17.176 4.5 15.8651 4.5 14.248V6.928C4.5 5.31091 5.81091 4 7.428 4H14.748C16.3651 4 17.676 5.31091 17.676 6.928V14.248Z"
                                    stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                                <path d="M10.252 20H17.572C19.1891 20 20.5 18.689 20.5 17.072V9.75195" stroke="#000000"
                                    stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                            </svg>
                        </div>
                        <div class="table-icon" @click="deleteContent()">
                            <svg xmlns="http://www.w3.org/2000/svg" width="800px" height="800px" viewBox="0 0 24 24"
                                fill="none">
                                <path d="M3 6.98996C8.81444 4.87965 15.1856 4.87965 21 6.98996" stroke="#000000"
                                    stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round" />
                                <path
                                    d="M8.00977 5.71997C8.00977 4.6591 8.43119 3.64175 9.18134 2.8916C9.93148 2.14146 10.9489 1.71997 12.0098 1.71997C13.0706 1.71997 14.0881 2.14146 14.8382 2.8916C15.5883 3.64175 16.0098 4.6591 16.0098 5.71997"
                                    stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                                <path d="M12 13V18" stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                                <path
                                    d="M19 9.98999L18.33 17.99C18.2225 19.071 17.7225 20.0751 16.9246 20.8123C16.1266 21.5494 15.0861 21.9684 14 21.99H10C8.91389 21.9684 7.87336 21.5494 7.07541 20.8123C6.27745 20.0751 5.77745 19.071 5.67001 17.99L5 9.98999"
                                    stroke="#000000" stroke-width="1.5" stroke-linecap="round"
                                    stroke-linejoin="round" />
                            </svg>
                        </div>
                    </div>
                </template>
            </td>
            <td>
                {{ props.item.article }}
            </td>
            <td>
                <div v-if="props.item.children.length" class="index__button item__button plus" @click="changeOpen()">
                    {{ openItems.inner[state.full] ? '-' : '+' }}
                </div>
            </td>
            <td>
                {{ state.type }}
            </td>
            <td>
                <div class="thumbnail" v-if="props.item.image"><img :src='"/photos/" + props.item.image'></div>
            </td>
            <td>
                {{ props.item.name }}
            </td>
            <td>
                {{ page.props.mats[props.item.material_id].short_name }}
            </td>
            <template v-if="props.isChild">
                <td>
                    {{ props.item.pivot.amount }}
                </td>
                <td>
                    {{ page.props.mets[props.item.measure_unit_id].short_name }}
                </td>
                <td v-html="formatMoney(props.item.calc_weight, 2, '.', ' ')">
                </td>
                <td v-html="formatMoney(props.item.price, 2, '.', ' ')">
                </td>
                <td v-if="!props.isDetail">
                </td>
                <td v-if="!props.isDetail">
                </td>
                <td v-if="!props.isDetail" v-html="formatMoney(Math.round(props.item.price * (1 + +props.parentSaleCoeff) * (1 + +props.parentSendCoeff) *
                    +props.item.pivot.amount), 2, '.', ' ')">
                </td>
                <td v-else v-html="formatMoney((props.item.price *
                    +props.item.pivot.amount), 2, '.', ' ')">
                </td>
                <td>
                    {{ props.item.price_date }}
                </td>
                <td>
                    {{ props.item.comment }}
                </td>
            </template>
            <template v-else>
                <td>

                </td>
                <td>
                    {{ page.props.mets[props.item.measure_unit_id].short_name }}
                </td>
                <td v-html="props.item.calc_weight">
                </td>
                <td v-html="formatMoney(props.item.price, 2, '.', ' ')">
                </td>
                <td v-if="!props.isDetail">
                    <input type="number" class="input-table" v-model="props.item.coeff_sale"
                        @change="changeParam('coeff_sale')">
                </td>
                <td v-if="!props.isDetail">
                    <input type="number" class="input-table" v-model="props.item.coeff_send"
                        @change="changeParam('coeff_send')">
                </td>
                <td v-if="!props.isDetail"
                    v-html="formatMoney((props.item.price * (1 + +props.item.coeff_sale) * (1 + +props.item.coeff_send)), 2, '.', ' ')">
                </td>
                <td v-else v-html="formatMoney((props.item.price), 2, '.', ' ')">
                </td>
                <td>
                    {{ props.item.phs[0] ? props.item.phs[props.item.phs.length - 1].date : props.item.price_date }}
                </td>
                <td>
                    {{ props.item.comment }}
                </td>
            </template>
        </template>
    </tr>
    <template v-if="props.isEngineering">
        <TableContent :parentId="state.full" :item="child"
            :parentSaleCoeff="props.isChild ? +props.parentSaleCoeff : +props.item.coeff_sale"
            :parentSendCoeff="props.isChild ? +props.parentSendCoeff : +props.item.coeff_send" :isChild="true"
            :isActive="openItems.inner[state.full] == 1" :isEngineering="props.isEngineering" :isDetail="props.isDetail"
            v-for="child in props.item.children">
        </TableContent>
        <tr class="gap" :class="{
            '_hidden': !openItems.inner[state.full],
        }"></tr>
    </template>
</template>
